<template>
  <div class="checkout-box">
    <header class="checkout-header">
      <h2>Add Inventory Update</h2>
    </header>
    <form @submit.prevent="addInventory">
      <div class="form-group">
        <label for="identity">WSU ID:</label>
        <input type="text" id="identity" name="identity" v-model="identity">
      </div>

      <div class="form-group">
        <label for="weightToAddLabel">Added Weight:</label>
        <input type="text" id="weightToAddInput" name="weightToAdd" v-model="weightToAdd">
      </div>

      <div class="form-group">
        <label for="adjusted">Adjusted Total: {{ adjustedTotal }}</label>
      </div>

      <div class="form-actions">
        <button type="button" @click="clearFields">Cancel</button>
        <button type="submit" :disabled="!weightToAdd">Submit</button>
      </div>
    </form>
  </div>
</template>

<script>
export default {
  name: 'AddInventoryPage',
  data() {
    return {
      identity: "",
      weightToAdd: "",
      InventoryTotal: "50", // Place-holder value until functionality is implemented
      adjustedTotal: "",
    };
  },

  methods: {
    async addInventory() {
      try {
      let identity = this.identity; // User's WSU ID
      let weightToAdd = this.weightToAdd; // Weight to add to the inventory

      // Log the input values for debugging purposes
       console.log(`${weightToAdd} lbs added, sourced by: ${identity}`);

      // Send the PATCH request to the backend with the weight to add
      const response = await fetch("http://localhost:10201/inventory", {
        method: "PATCH",
        headers: {
          "Content-Type": "application/json",
        },
        body: JSON.stringify({ weight: parseFloat(weightToAdd) }), // Send the weight as a floating-point number
      });

      // Check if the response is successful (status 200)
      if (response.ok) {
        // Parse the JSON response to get the updated inventory weight
        const data = await response.json();
        
        // Check if the response contains the number we want
        if (data !== undefined && typeof data === 'number') {
          // Format the number to 2 decimal places
          this.adjustedTotal = data.toFixed(2);
         
        } else {
        
          this.adjustedTotal = "Error: Invalid response format";
        }
      } else {
        this.adjustedTotal = "Error updating inventory"; // Set an error message to the adjustedTotal
      }

      // Clear the input fields after submission
      this.identity = "";
      this.weightToAdd = "";
    } catch (error) {
      this.adjustedTotal = "Error"; // Set an error message to the adjustedTotal
    }
  }
}
}
</script>

<style scoped>
.checkout-box {
  border: 1px solid #ccc;
  padding: 20px;
  margin: 20px auto;
  width: 300px;
  box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
  border-radius: 5px;
}

.checkout-header h2 {
  margin-top: 0;
  text-align: center;
  font-size: 1.5rem;
  font-weight: bold;
  margin-bottom: 20px;
}

form {
  display: flex;
  flex-direction: column;
}

.form-group {
  display: flex;
  margin-bottom: 20px;
  align-items: center;
}

.form-group label {
  margin-right: 10px;
}

.form-actions {
  display: flex;
  justify-content: flex-end;
  gap: 10px;
}

.form-actions button {
  padding: 10px 20px;
  border: none;
  border-radius: 5px;
  font-weight: bold;
  cursor: pointer;
  transition: transform 0.2s ease-in-out, box-shadow 0.2s ease-in-out;
}

.form-actions button[type="submit"] {
  background-color: #0077ff;
  color: white;
  border-radius: 5px;
  padding: 10px 20px;
  font-weight: bold;
  cursor: pointer;
  transition: transform 0.2s ease-in-out, box-shadow 0.2s ease-in-out;
}

.form-actions button[type="submit"]:disabled {
  background-color: #a0c4ff;
  cursor: not-allowed;
}

.form-actions button[type="submit"]:hover {
  background-color: #005bb5;
  transform: scale(1.05);
  box-shadow: 0 4px 8px rgba(0, 0, 0, 0.3);
}

.form-actions button[type="submit"]:active {
  background-color: #004085;
  transform: scale(0.95);
}

@media (max-width: 600px) {
  .checkout-box {
    width: 100%;
    margin: 10px;
  }

  button {
    width: 100%;
  }

  input[type="text"] {
    width: 100%;
  }
}
</style>
